<?php
/*
 Motion detection and alerting script.
 Version: 0.1
 Author: NLD 2018/04/26
*/

/* Shared variables */
@set_time_limit(0);
@ini_set('max_execution_time', 0);

function email_alert($alert_time) {
 $to = "admin@yourdomain.com";
 $txt=$subject = "Motion detected at: $alert_time";
 $headers = "From: phoenix@yourcamera.com";
 mail($to,$subject,$txt,$headers);
}

function process_logs($filename) {

$opt['alert_after']='09:00:00';  // Mornings
$opt['alert_before']='17:00:00'; // Evenings


  $file = fopen($filename, 'r');
  if ($file===false) {
        echo "Can't open logfile for processing.\n";
        return 0;
        }

  if ( 0 == filesize( $filename) )
        {
        return 0;
        }

  while (!feof($file)) {

    $line = fgets($file);
    // echo 'Line:'.($line);
    if (preg_match("/Motion Detected/i", $line))
        {
            echo "===============================\n";

            preg_match('/(\d{2}):(\d{2}):(\d{2})/', $line, $date);

            if ( strlen($date[0]) < 5 )
                {
                 echo 'Bad time format (skipping line): '.  $date[0] . "\n";
                 continue;
                }

            $time=$date[0];

            if (strtotime($time) >= strtotime($opt['alert_after']) && strtotime($time) <= strtotime($opt['alert_before'])) {
                email_alert($time);
                $alert=true;
           }
            echo 'Event time: '. $time."\n";
            echo 'Alert after (MORNING): ' . $opt['alert_after']."\n";
            echo 'Alert before(EVENING): ' . $opt['alert_before']."\n";
            if ($alert)
                echo "Alert: ON\n";
            else
                echo "Alert: OFF\n";
            echo "===============================\n";

        }


  }
  fclose($file);
}

// Main program

   $logfile="/var/log/phoenix/deathstar.log";
   $logfile2=getcwd()."/motion.data";
   $offsetfile=getcwd()."/motion.offset";

   if(!is_writable($offsetfile))
        exit("Offset file: ".$offsetfile." cannot be opened for writing, exiting.\n");

   $cmd = "logtail -o".$offsetfile.' '.$logfile.'>'.$logfile2;
   exec($cmd);

// Simple hack, on the weekends go through the logs so they wasted but don't process them.
   if($argv[1]!="weekend")
    process_logs($logfile2);

   unlink($logfile2);

?>
